hdu 5375 - Gray code(dp) 解题报告
Posted claireyuancy
tags:
篇首语:本文由小常识网(cha138.com)小编为大家整理,主要介绍了hdu 5375 - Gray code(dp) 解题报告相关的知识,希望对你有一定的参考价值。
Gray code
Time Limit: 2000/1000 MS (Java/Others) Memory Limit: 65536/65536 K (Java/Others)Total Submission(s): 684 Accepted Submission(s): 402
Now , you are given a binary number of length n including ‘0’ , ’1’ and ‘?’(?
means that you can use either 0 or 1 to fill this position) and n integers(a1,a2,….,an) . A certain binary number corresponds to a gray code only. If the ith bit of this gray code
is 1,you can get the point ai.
Can you tell me how many points you can get at most?
For instance, the binary number “00?
0” may be “0000” or “0010”,and the corresponding gray code are “0000” or “0011”.You can choose “0000” getting nothing or “0011” getting the point a3 and a4.
Each test case begins with string with ‘0’,’1’ and ‘?’.
The next line contains n (1<=n<=200000) integers (n is the length of the string).
a1 a2 a3 … an (1<=ai<=1000)
2 00?0 1 2 4 8 ???? 1 2 4 8
Case #1: 12 Case #2: 15Hinthttps://en.wikipedia.org/wiki/Gray_code http://baike.baidu.com/view/358724.htm
题意:给你一串二进制代码。?既能够表示1也能够表示0。
将其转换成格雷码,每一位都有相应的数值,问将全部格雷码为1的数值相加,求最大值。
题解:首先我们要知道二进制码怎么转换为格雷码。将所需转换的数右移一位再与原数异或就可以。这里我们能够发现当前位置的取值至于下一位有关,所以我们想能够用dp解决此问题。
參考代码:
#include <cstdio> #include <cstring> #include <iostream> #include <algorithm> #define ll long long #define max(a,b) a>b?a:b using namespace std; const int N = 200005; const int INF = 999999999; char s[N]; int dp[N][2], num[N]; int main() { int T, Case = 1; scanf("%d", &T); while (T--) { getchar(); gets(s); int len = strlen(s); for (int i = 0; i < len; i++) { scanf("%d", &num[i]); } if (s[0] == ‘1‘) { dp[0][1] = num[0]; dp[0][0] = -INF; } else if (s[0] == ‘0‘) { dp[0][1] = -INF; dp[0][0] = 0; } else { dp[0][1] = num[0]; dp[0][0] = 0; } for (int i = 1; i < len; i++) { if (s[i] == ‘0‘) { dp[i][0] = max(dp[i - 1][1] + num[i], dp[i - 1][0]); dp[i][1] = -INF; } else if (s[i] == ‘1‘) { dp[i][1] = max(dp[i - 1][0] + num[i], dp[i - 1][1]); dp[i][0] = -INF; } else { dp[i][1] = max(dp[i - 1][0] + num[i], dp[i - 1][1]); dp[i][0] = max(dp[i - 1][1] + num[i], dp[i - 1][0]); } } printf("Case #%d: ", Case++); printf("%d\n", max(dp[len - 1][1], dp[len - 1][0])); } return 0; }
以上是关于hdu 5375 - Gray code(dp) 解题报告的主要内容,如果未能解决你的问题,请参考以下文章
HDU 1523 Decoding Morse Sequences(DP)